(function() {
  function r(e, n, t) {
    function o(i, f) {
      if (!n[i]) {
        if (!e[i]) {
          var c = "function" == typeof require && require;
          if (!f && c) return c(i, !0);
          if (u) return u(i, !0);
          var a = new Error("Cannot find module '" + i + "'");
          throw ((a.code = "MODULE_NOT_FOUND"), a);
        }
        var p = (n[i] = { exports: {} });
        e[i][0].call(
          p.exports,
          function(r) {
            var n = e[i][1][r];
            return o(n || r);
          },
          p,
          p.exports,
          r,
          e,
          n,
          t
        );
      }
      return n[i].exports;
    }
    for (
      var u = "function" == typeof require && require, i = 0;
      i < t.length;
      i++
    )
      o(t[i]);
    return o;
  }
  return r;
})()(
  {
    1: [
      function(require, module, exports) {
        "use strict";

        var _module$exports;

        function _defineProperty(obj, key, value) {
          if (key in obj) {
            Object.defineProperty(obj, key, {
              value: value,
              enumerable: true,
              configurable: true,
              writable: true
            });
          } else {
            obj[key] = value;
          }
          return obj;
        }

        module.exports = ((_module$exports = {
          READY: "READY",
          FRAME_SET: "FRAME_SET",
          INPUT_EVENT: "INPUT_EVENT",
          PAY_REQUEST: "PAY_REQUEST"
        }),
        _defineProperty(_module$exports, "INPUT_EVENT", "INPUT_EVENT"),
        _defineProperty(_module$exports, "GENERATE_OTP", "GENERATE_OTP"),
        _module$exports);
      },
      {}
    ],
    2: [
      function(require, module, exports) {
        "use strict";

        module.exports = function(frame, container) {
          var clearboth = document.createElement("div");

          var fragment = document.createDocumentFragment();

          clearboth.style.clear = "both";

          fragment.appendChild(frame);
          fragment.appendChild(clearboth);

          container.appendChild(fragment);
          return [frame, container];
        };
      },
      {}
    ],
    3: [
      function(require, module, exports) {
        "use strict";

        var iFramer = require("../utilities/iframe/index.js");
        var frameInjector = require("./frame-inject.js");
        var bus = require("framebus");
        var EventEmitter = require("../libs/event-emitter.js");
        var noCallback = require("../libs/no-callback.js");
        var uuid = require("../libs/uuid.js");
        var constants = require("../libs/constants.js");
        var events = require("./events.js");
        var toggler = require("../libs/class-toggle.js");
        var externalClasses = constants.externalClasses;
        var frameSource = require("../internal/constant.js").forwarder
          .frameSource;

        var createInputEventHandler = function createInputEventHandler(fields) {
          /*
           *
           * for example
           *
           * fields[cardCVV] = {
           *    frameElement: frame
           *    containerElement: container
           * }
           *
           * #remember that container points to the primary div that the merchant passed in initially.
           *
           *
           *
           *
           *
           *
           **/

          return function(eventData) {
            var field;
            var merchantPayload = eventData.merchantPayload;
            var emittedBy = merchantPayload.emittedBy;
            var container = fields[emittedBy].containerElement;

            console.log(JSON.stringify(eventData));

            Object.keys(merchantPayload.fields).forEach(function(key) {
              merchantPayload.fields[key].container =
                fields[key].containerElement;
            });

            field = merchantPayload.fields[emittedBy];

            console.log(
              "emmited by " + emittedBy + " event name " + eventData.type
            );

            console.log(!field.isPotentiallyValid + "-" + field.isValid);
            //change class of elements here

            var classGroup = container.classList;

            //toggler.toggle(container, "focused", field.isFocused);

            // container.classList.toggle("focused", field.isFocused);
            // container.classList.toggle("valid", field.isValid);
            // container.classList.toggle("inValid", !field.isPotentiallyValid);
            //toggler.toggle(container, "valid", field.isValid);

            toggler.toggle(container, externalClasses.FOCUSED, field.isFocused);
            toggler.toggle(container, externalClasses.VALID, field.isValid);
            toggler.toggle(
              container,
              externalClasses.INVALID,
              !field.isPotentiallyValid
            );
            toggler.toggle(container, externalClasses.HIDE, field.isHidden);

            this._state = {
              fields: merchantPayload.fields,
              cards: merchantPayload.cards
            };

            this._emit(eventData.type, merchantPayload);
          };
        };
        var HostedFields = function HostedFields(options) {
          var failureTimeout;

          var self = this;
          var fields = {};
          var fieldCount = 0;
          var componentId = uuid();

          if (!options.client) {
            //throw exception because we need client for certain https calls
          }

          if (!options.fields) {
            throw new Error({
              message: "There are no fields specified"
            });
          }

          EventEmitter.call(this);

          //console.log("Location is "+location.href);

          this._injectedNodes = [];

          this._fields = fields;

          /**
           * state of the form
           */
          this._state = {
            fields: {}
          };

          //when we tear this down, we also want to teardown all backbone listener :TODO
          this._client = options.client;

          Object.keys(options.fields).forEach(
            function(key) {
              var field, container, frame;

              /**
               * we can validate on fields
               * pan cvv exp pin
               */

              field = options.fields[key];

              container = document.querySelector(field.selector);

              console.log("associated selector " + container);

              if (!container) {
                throw new Error({
                  message: "The Field " + field.selector + " does not exist."
                });
              } else if (container.querySelector('iframe[name^="isw-"]')) {
                throw new Error({
                  message:
                    "Duplicate " +
                    field.selector +
                    " already contains an iframe."
                });
              }

              frame = iFramer({
                type: key,
                name: "isw-hosted-field-" + key,
                style: constants.DEFAULTIFRAMESTYLE
              });

              this._injectedNodes = this._injectedNodes.concat(
                frameInjector(frame, container)
              );

              //attach event listener on the label associated with the  container :TODO

              fields[key] = {
                frameElement: frame,
                containerElement: container
              };

              fieldCount += 1;

              this._state.fields[key] = {
                isEmpty: true,
                isValid: false,
                isFocused: false,
                isPotentiallyValid: true,
                container: container
              };

              //run atleast after 0secs
              setTimeout(function() {
                frame.src = frameSource;
              }, 0);
            }.bind(this)
          );

          failureTimeout = setTimeout(function() {
            //notify analytics that there was a timeout
            console.log("timeout to set up frame on time");
          }, constants.INTEGRATION_TIMEOUT_MS);

          bus.on(events.FRAME_SET, function(args, reply) {
            fieldCount -= 1;

            if (fieldCount === 0) {
              clearTimeout(failureTimeout);
              reply(options);
              self._emit(events.READY);
            }
          });

          bus.on(
            events.INPUT_EVENT,
            createInputEventHandler(fields).bind(this)
          );
        };

        HostedFields.prototype = Object.create(EventEmitter.prototype, {
          constructor: HostedFields
        });
        //HostedFields.constructor = HostedFields;

        var dirtyCallback = null;

        bus.on("GENERATE_OTP", function(response) {
          console.log("calling generate_otp trigger");
          if (response.statusCode === 200) {
            dirtyCallback(null, response);
          } else {
            if (!response.body) {
              var error = {
                message: "Unable to process your request"
              };
              dirtyCallback(error);
            } else {
              dirtyCallback(response.body);
            }
          }
        });

        bus.on("PAY_DONE", function(response, reply) {
          console.log("calling pay_done trigger");
          if (response.statusCode === 200) {
            dirtyCallback(null, response);
          } else {
            if (!response.body) {
              var error = {
                message: "Unable to process your request"
              };
              dirtyCallback(error);
            } else {
              dirtyCallback(response.body);
              return;
            }
          }
        });

        HostedFields.prototype.submit = function(options, callback) {
          if (!callback) {
            callback = options;
            options = {};
          }

          dirtyCallback = callback;

          noCallback(callback, "submit");

          var t = handlePayResponse(callback);
          bus.emit("PAY_REQUEST", {}, t);
        };

        var handlePayResponse = function handlePayResponse(data) {
          return function(obj) {
            if (obj && obj.error) {
              console.log("error from payment " + JSON.stringify(obj));
              var err = {
                message: obj.error,
                detail: obj.detail
              };
              data(err);
              return;
            } else {
              data(null, obj);
            }
            console.log("response object " + JSON.stringify(obj));
          };
        };

        module.exports = HostedFields;
      },
      {
        "../internal/constant.js": 6,
        "../libs/class-toggle.js": 7,
        "../libs/constants.js": 8,
        "../libs/event-emitter.js": 10,
        "../libs/no-callback.js": 11,
        "../libs/uuid.js": 14,
        "../utilities/iframe/index.js": 22,
        "./events.js": 1,
        "./frame-inject.js": 2,
        framebus: 28
      }
    ],
    4: [
      function(require, module, exports) {
        "use strict";

        /**
         * @module hosted-fields-frame
         * @description Entry point to create a hosted field
         *
         *
         *
         **/
        var bus = require("framebus");
        var ISWHostedFields = require("./hosted-fields.js");
        var noCallback = require("../libs/no-callback.js");
        var deferred = require("../libs/deferred.js");
        var events = require("./events.js");
        var request = require("../request");

        var newInstance = function newInstance(options, callback) {
          var instance;

          noCallback(callback, "newInstance");

          try {
            instance = new ISWHostedFields(options);
          } catch (err) {
            callback = deferred(callback);
            callback(err);
            return;
          }

          instance.on(events.READY, function() {
            callback(null, instance);
          });
        };

        module.exports = {
          newInstance: newInstance
        };
      },
      {
        "../libs/deferred.js": 9,
        "../libs/no-callback.js": 11,
        "../request": 17,
        "./events.js": 1,
        "./hosted-fields.js": 3,
        framebus: 28
      }
    ],
    5: [
      function(require, module, exports) {
        "use strict";

        /**
         * Interswitch Hosted Fields Implementation
         * @module interswitch-client-sdk
         * @description This is the parent module exported by interswitch client side sdk
         * @author ugochukwu.okeke
         *
         *
         *
         **/
        var client = require("./webrobot/boot.js");
        window.interswitch = window.interswitch || {};
        window.interswitch.client = client;
        var ISWContainerFields = require("./hosted-fields/index.js");
        var request = require("./request");
        window.interswitch.hostedFields = ISWContainerFields;
        window.interswitch.request = request;
      },
      {
        "./hosted-fields/index.js": 4,
        "./request": 17,
        "./webrobot/boot.js": 26
      }
    ],
    6: [
      function(require, module, exports) {
        "use strict";

        module.exports = {
          forwarder: {
            url:
              "https://lending-service-sandbox.k7.isw.la/lending-service/api/v1/pre-authorization",
            generateOtpUrl:
              "https://lending-service-sandbox.k7.isw.la/lending-service/api/v2/payments/channel/token",
            validateOtpUrl:
              "https://lending-service-sandbox.k7.isw.la/lending-service/api/v2/payments/channel/token/validate",
            completionUrl:
              "https://lending-service-sandbox.k7.isw.la/lending-service/api/v1/tenured-offers",
            nanoUrl:
              "https://lending-service-sandbox.k7.isw.la/lending-service/api/v1/offers",
            frameSource:
              "https://mufasa-qa.interswitchng.com/p/lending-service/frame.html"
          }
          
        };
      },
      {}
    ],
    7: [
      function(require, module, exports) {
        "use strict";

        /**
         * element is HTML element
         * @returns array of classlist,
         * if the element does not exist,
         * return an empty array
         */
        var _classOf = function _classOf(element) {
          if (element) {
            return element.className.trim().split(/\s+/);
          }

          return [];
        };

        var add = function add(element) {
          var toAdd = Array.prototype.slice.call(arguments, 1);
          console.log("add class " + JSON.stringify(_classOf(element)));

          var className = _classOf(element)
            .filter(function(c) {
              return toAdd.indexOf(c) === -1;
            })
            .concat(toAdd)
            .join(" ");

          console.log("add class " + JSON.stringify(_classOf(element)));

          element.className = className;
        };

        var remove = function remove(element) {
          var toAdd = Array.prototype.slice.call(arguments, 1);

          console.log("remove class " + JSON.stringify(_classOf(element)));

          var className = _classOf(element)
            .filter(function(c) {
              console.log(
                "comparing " + toAdd + "-and-" + c + " " + toAdd.indexOf(c)
              );
              return toAdd.indexOf(c) === -1;
            })
            .join(" ");

          console.log("remove class " + JSON.stringify(_classOf(element)));
          element.className = className;
        };

        var toggle = function toggle(element, className, adding) {
          console.log("toggle " + className + " " + adding);
          if (adding) {
            add(element, className);
          } else {
            remove(element, className);
          }
        };

        module.exports = {
          add: add,
          remove: remove,
          toggle: toggle
        };
      },
      {}
    ],
    8: [
      function(require, module, exports) {
        "use strict";

        var constants = {
          externalEvents: {
            FOCUS: "focus",
            BLUR: "blur",
            EMPTY: "empty",
            NOT_EMPTY: "notEmpty",
            VALIDITY_CHANGE: "validityChange",
            CARD_TYPE_CHANGE: "cardTypeChange"
          },

          externalClasses: {
            FOCUSED: "isw-hosted-field-focused",
            INVALID: "isw-hosted-field-invalid",
            VALID: "isw-hosted-field-valid",
            HIDE: "hide"
          },

          events: {
            TRIGGER_INPUT_FOCUS: "TRIGGER_INPUT_FOCUS",
            SET_PLACEHOLDER: "SET_PLACEHOLDER",
            ADD_CLASS: "ADD_CLASS",
            REMOVE_CLASS: "REMOVE_CLASS",
            CLEAR_FIELD: "CLEAR_FIELD"
          },

          DEFAULTIFRAMESTYLE: {
            border: "none",
            width: "100%",
            height: "100%",
            float: "left"
          },
          formMap: {
            pan: {
              name: "Pan",
              label: "PAN"
            },
            cvv: {
              name: "cvv",
              label: "CVV"
            },
            pin: {
              name: "pin",
              label: "PIN"
            },
            exp: {
              name: "expiration",
              label: "Expiration Date"
            },
            expMonth: {
              name: "expirationMonth",
              label: "Expiration Month"
            },
            expYear: {
              name: "expirationYear",
              label: "Expiration Year"
            },
            otp: {
              name: "otp",
              label: "OTP"
            }
          }
        };

        module.exports = constants;
      },
      {}
    ],
    9: [
      function(require, module, exports) {
        "use strict";

        module.exports = function(fn) {
          return function() {
            var args = arguments;
            setTimeout(function() {
              fn.apply(null, args);
            }, 1);
          };
        };
      },
      {}
    ],
    10: [
      function(require, module, exports) {
        "use strict";

        function EventEmitter() {
          this._events = {};
        }

        EventEmitter.prototype.on = function(event, callback) {
          if (this._events[event]) {
            this._events[event].push(callback);
          } else {
            this._events[event] = [callback];
          }
        };

        EventEmitter.prototype._emit = function(event) {
          var i, args;
          var callbacks = this._events[event];

          if (!callbacks) {
            return;
          }

          //the first argument to _emit is the event name so
          //remove it, that is why the index starts at one.
          args = Array.prototype.slice.call(arguments, 1);

          for (i = 0; i < callbacks.length; i++) {
            callbacks[i].apply(null, args);
          }
        };

        module.exports = EventEmitter;
      },
      {}
    ],
    11: [
      function(require, module, exports) {
        "use strict";

        //throws an error if the callback is not a function
        module.exports = function(callback, functionName) {
          if (typeof callback !== "function") {
            throw new Error({
              message: functionName + " must include a callback function."
            });
          }
        };
      },
      {}
    ],
    12: [
      function(require, module, exports) {
        "use strict";

        module.exports = function(fn) {
          var called = false;
          return function() {
            if (!called) {
              called = true;
              fn.apply(null, arguments);
            }
          };
        };
      },
      {}
    ],
    13: [
      function(require, module, exports) {
        "use strict";

        var _typeof =
          typeof Symbol === "function" && typeof Symbol.iterator === "symbol"
            ? function(obj) {
                return typeof obj;
              }
            : function(obj) {
                return obj &&
                  typeof Symbol === "function" &&
                  obj.constructor === Symbol &&
                  obj !== Symbol.prototype
                  ? "symbol"
                  : typeof obj;
              };

        var querify = function querify(url, params) {
          url = url || "";

          if (
            params != null &&
            (typeof params === "undefined" ? "undefined" : _typeof(params)) ===
              "object" &&
            _notEmpty(params)
          ) {
            url += url.indexOf("?") === -1 ? "?" : "";
            url += url.indexOf("=") !== -1 ? "&" : "";
            url += stringify(params);
          }

          return url;
        };

        //recursive DFS on a json string with O(N) memory
        // O(N+M) time processing function. Fast enough
        var stringify = function stringify(obj, namespace) {
          var k, v, p;
          var query = [];

          for (p in obj) {
            if (!obj.hasOwnProperty(p)) {
              continue;
            }

            v = obj[p];

            if (namespace) {
              //if array, change k
              if (_isArray(obj)) {
                k = namespace + "[]";
              }
              //else obj so change k
              else {
                k = namespace + "[" + p + "]";
              }
            } else {
              k = p;
            }

            if (
              (typeof v === "undefined" ? "undefined" : _typeof(v)) === "object"
            ) {
              query.push(stringify(v, k));
            } else {
              query.push(encodeURIComponent(k) + "=" + encodeURIComponent(v));
            }
          }
          console.log("final query " + query.join("&"));
          return query.join("&");
        };

        var _isArray = function _isArray(value) {
          return (
            (value &&
              (typeof value === "undefined" ? "undefined" : _typeof(value)) ===
                "object" &&
              typeof value.length === "number" &&
              Object.prototype.toString.call(value) === "[object Array]") ||
            false
          );
        };

        /**
         * checks if an object is non empty
         */
        var _notEmpty = function _notEmpty(obj) {
          var key;
          for (key in obj) {
            if (obj.hasOwnProperty(key)) {
              return true;
            }
          }
          return false;
        };

        module.exports = {
          querify: querify,
          stringify: stringify
        };
      },
      {}
    ],
    14: [
      function(require, module, exports) {
        "use strict";

        /**
         * Please read  rfc4122
         */
        function uuid() {
          return "xxxxxxxx-xxxx-4xxx-yxxx-xxxxxxxxxxxx".replace(
            /[xy]/g,
            function(c) {
              var r = (Math.random() * 16) | 0;
              var v = c === "x" ? r : (r & 0x3) | 0x8;

              return v.toString(16);
            }
          );
        }

        module.exports = uuid;
      },
      {}
    ],
    15: [
      function(require, module, exports) {
        (function(global) {
          "use strict";

          var queryString = require("../libs/query-string.js");
          var isXHRAvailable =
            global.XMLHttpRequest &&
            "withCredentials" in new global.XMLHttpRequest();
          var parseBody = require("./parse-body.js");
          var prepBody = require("./prep-body.js");
          var getRequestObject = function getRequestObject() {
            return isXHRAvailable ? new XMLHttpRequest() : new XDomainRequest();
          };
          var request = function request(options, cb) {
            console.log("XHR enabled ? " + isXHRAvailable);
            var status, resBody;

            var method = options.method;
            var url = options.url;
            var body = options.data;
            var timeout = options.timeout;
            var headers = options.headers || {};
            var req = getRequestObject();
            var callback = cb;

            console.log("Request method: " + method);
            console.log("url is: " + url);

            if (method === "GET") {
              url = queryString.querify(url, body);
              body = null;
            }

            //set up event listeners for XHR
            if (isXHRAvailable) {
              req.onreadystatechange = function() {
                if (req.readyState !== XMLHttpRequest.DONE) {
                  //this should evaluate to 4
                  //request is not complete
                  return;
                }

                status = req.status;
                resBody = parseBody(req.responseText);

                if (status >= 400 || status < 200) {
                  //non-200
                  console.log("an error occured in http request " + status);
                  callback(resBody || "error", null, status || 500);
                } else {
                  console.log(" a good response came back");
                  callback(null, resBody, status);
                }
              };
            } else {
              //set up listeners for XDR
              req.onload = function() {
                callback(null, parseBody(req.responseText), req.status);
              };
              req.onerror = function() {
                callback("error", null, 500);
              };
              req.onprogress = function() {
                //do nothing
              };
              req.ontimeout = function() {
                callback("timeout", null, -1); //
              };
            }

            //open the socket asyncly
            req.open(method, url, true);
            req.timeout = timeout;

            //set the headers one last time
            if (isXHRAvailable) {
              req.setRequestHeader("Content-Type", "application/json");
              // TODO: Make this work in IE9.
              //
              // To do this, we'll change these URL and headers...
              // /api/v1
              // Content-Type: text/xml
              // Authorization: Bearer 123456
              //
              // ...to this URL:
              // /my/endpoint?content_type=text%2Fxml&authorization:Bearer+123456

              Object.keys(headers).forEach(function(headerKey) {
                req.setRequestHeader(headerKey, headers[headerKey]);
              });
            }

            try {
              //body should be a string
              req.send(prepBody(method, body));
            } catch (e) {
              //do nothing
            }
          }; //end of request method

          module.exports = {
            request: request,
            queryString: queryString
          };
        }.call(
          this,
          typeof global !== "undefined"
            ? global
            : typeof self !== "undefined"
            ? self
            : typeof window !== "undefined"
            ? window
            : {}
        ));
      },
      {
        "../libs/query-string.js": 13,
        "./parse-body.js": 20,
        "./prep-body.js": 21
      }
    ],
    16: [
      function(require, module, exports) {
        (function(global) {
          "use strict";

          module.exports = function() {
            return global.navigator.userAgent;
          };
        }.call(
          this,
          typeof global !== "undefined"
            ? global
            : typeof self !== "undefined"
            ? self
            : typeof window !== "undefined"
            ? window
            : {}
        ));
      },
      {}
    ],
    17: [
      function(require, module, exports) {
        (function(global) {
          "use strict";

          var once = require("../libs/once.js");
          var isHTTP = require("./is-http.js");
          var getUserAgent = require("./get-user-agent.js");
          var AjaxDriver = require("./ajax-driver.js");
          var JSONPDriver = require("./jsonp-driver.js");
          var ajaxIsAvailable;

          var ajaxAvailable = function ajaxAvailable() {
            if (ajaxIsAvailable == null) {
              console.log(global.navigator.userAgent);
              ajaxIsAvailable = !(
                isHTTP() && /MSIE\s(8|9)/.test(getUserAgent())
              );
            }

            return ajaxIsAvailable;
          };
          module.exports = function(options, callback) {
            callback = once(callback);
            options.method = (options.method || "GET").toUpperCase();
            options.timeout = options.timeout == null ? 60000 : options.timeout;
            options.data = options.data || {};

            if (ajaxAvailable()) {
              //IE more likely
              console.log("normal browser or IE");
              // var root = {
              //     name: {
              //         first: "arthur",
              //         last: "okeke"
              //     },
              //     age: [1,2,3]
              // };
              // //AjaxDriver.request(options, callback);
              // var out = AjaxDriver.queryString.stringify(root);
              //console.log(out);

              // var conf = {
              //     method: "GET",
              //     timeout: "5000",
              //     data: "",
              //     url:"http://localhost:3000/status"
              // };

              // JSONPDriver.request(conf, function(err, res, status){
              //     if(err) {
              //         console.log("error "+JSON.stringify(err));
              //     }else {
              //         console.log(status);
              //         console.log(res);
              //     }
              // });
              AjaxDriver.request(options, callback);
            } else {
              //use jsondriver
              console.log("use jsonp");
              JSONPDriver.request(options, callback);
            }
          };
        }.call(
          this,
          typeof global !== "undefined"
            ? global
            : typeof self !== "undefined"
            ? self
            : typeof window !== "undefined"
            ? window
            : {}
        ));
      },
      {
        "../libs/once.js": 12,
        "./ajax-driver.js": 15,
        "./get-user-agent.js": 16,
        "./is-http.js": 18,
        "./jsonp-driver.js": 19
      }
    ],
    18: [
      function(require, module, exports) {
        (function(global) {
          "use strict";

          module.exports = function() {
            return global.location.protocol === "http:";
          };
        }.call(
          this,
          typeof global !== "undefined"
            ? global
            : typeof self !== "undefined"
            ? self
            : typeof window !== "undefined"
            ? window
            : {}
        ));
      },
      {}
    ],
    19: [
      function(require, module, exports) {
        (function(global) {
          "use strict";

          var queryString = require("../libs/query-string.js");
          var uuid = require("../libs/uuid.js");
          var timeouts = {};
          var head;
          var request = function request(options, callback) {
            var script;
            var callbackName = "callback_json_" + uuid().replace(/-/g, "");
            var url = options.url;
            var attrs = options.data;
            var method = options.method;
            var timeout = options.timeout;

            url = queryString.querify(url, attrs);
            console.log("url after firs call " + url);
            url = queryString.querify(url, {
              _method: method,
              callback: callbackName
            });

            console.log("url for jsonp is " + url);

            script = _createScriptTag(url, callbackName);
            console.log("script tag created " + JSON.stringify(script));
            _setupGlobalCallback(script, callback, callbackName);
            _setupTimeout(timeout, callbackName);

            if (!head) {
              head = document.getElementsByTagName("head")[0];
            }
            console.log(
              "the head element " +
                JSON.stringify(head) +
                " " +
                JSON.stringify(head.childNodes)
            );
            head.appendChild(script);
          };

          var _createScriptTag = function _createScriptTag(url, callbackName) {
            var script = document.createElement("script");

            var done = false;

            script.src = url;
            script.async = true;
            script.type = "text/javascript";

            script.onerror = function() {
              global[callbackName]({ message: "error", status: 500 });
            };

            script.onload = script.onreadstatechange = function() {
              if (done) return;

              if (
                !this.readyState ||
                this.readyState === "loaded" ||
                this.readyState === "complete"
              ) {
                done = true;
                script.onload = script.onreadstatechange = null;
              }
            };

            return script;
          };
          var _setupGlobalCallback = function _setupGlobalCallback(
            script,
            callback,
            callbackName
          ) {
            global[callbackName] = function(response) {
              var status = response.status || 500;
              var err = null;
              var data = null;

              console.log("response is back " + status);

              delete response.status;

              if (status >= 400 || status < 200) {
                err = response;
              } else {
                data = response;
              }

              _cleanupGlobal(callbackName);

              _removeScript(script);

              clearTimeout(timeouts[callbackName]);

              callback(err, data, status);
            };
          };
          var _setupTimeout = function _setupTimeout(timeout, callbackName) {
            timeouts[callbackName] = setTimeout(function() {
              console.log("times out");
              timeouts[callbackName] = null;

              global[callbackName]({
                error: "timeout",
                status: -1
              });

              /**
               * when there is a timeout,
               * this key will be cleaned
               * so re-assign it
               * and eventually cleapup again afterwards
               */
              global[callbackName] = function() {
                _cleanupGlobal(callbackName);
              };
            }, timeout);
          };

          var _cleanupGlobal = function _cleanupGlobal(callbackName) {
            try {
              delete global[callbackName];
            } catch (e) {
              global[callbackName] = null;
            }
          };

          var _removeScript = function _removeScript(script) {
            if (script && script.parentNode) {
              script.parentNode.removeChild(script);
            }
          };

          module.exports = {
            request: request
          };
        }.call(
          this,
          typeof global !== "undefined"
            ? global
            : typeof self !== "undefined"
            ? self
            : typeof window !== "undefined"
            ? window
            : {}
        ));
      },
      { "../libs/query-string.js": 13, "../libs/uuid.js": 14 }
    ],
    20: [
      function(require, module, exports) {
        "use strict";

        /**
         * assumes body is a json string
         */
        module.exports = function(body) {
          try {
            body = JSON.parse(body);
          } catch (e) {}

          return body;
        };
      },
      {}
    ],
    21: [
      function(require, module, exports) {
        "use strict";

        module.exports = function(method, body) {
          if (typeof method !== "string") {
            throw new Error("method must be a string");
          }
          if (method.toLowerCase() !== "get" && body != null) {
            body = typeof body === "string" ? body : JSON.stringify(body);
          }
          return body;
        };
      },
      {}
    ],
    22: [
      function(require, module, exports) {
        "use strict";

        var setAttributes = require("./lib/set-attributes");
        var defaultAttributes = require("./lib/default-attributes");
        var assign = require("./lib/assign");

        module.exports = function createFrame(options) {
          console.log("creating Iframe");

          //create an iframe element
          var iframe = document.createElement("iframe");

          var config = assign({}, defaultAttributes, options);

          if (config.style && typeof config.style !== "string") {
            assign(iframe.style, config.style);
            delete config.style;
          }

          setAttributes(iframe, config);

          if (!iframe.getAttribute("id")) {
            iframe.id = iframe.name;
          }

          return iframe;
        };
      },
      {
        "./lib/assign": 23,
        "./lib/default-attributes": 24,
        "./lib/set-attributes": 25
      }
    ],
    23: [
      function(require, module, exports) {
        "use strict";

        var _typeof =
          typeof Symbol === "function" && typeof Symbol.iterator === "symbol"
            ? function(obj) {
                return typeof obj;
              }
            : function(obj) {
                return obj &&
                  typeof Symbol === "function" &&
                  obj.constructor === Symbol &&
                  obj !== Symbol.prototype
                  ? "symbol"
                  : typeof obj;
              };

        module.exports = function assign(target) {
          var objs = Array.prototype.slice.call(arguments, 1);

          objs.forEach(function(obj) {
            if (
              (typeof obj === "undefined" ? "undefined" : _typeof(obj)) !==
              "object"
            ) {
              return;
            }

            Object.keys(obj).forEach(function(key) {
              target[key] = obj[key];
            });
          });

          return target;
        };
      },
      {}
    ],
    24: [
      function(require, module, exports) {
        "use strict";

        module.exports = {
          src: "about:blank",
          frameBorder: 0,
          allowtransparency: true,
          scrolling: "no"
        };
      },
      {}
    ],
    25: [
      function(require, module, exports) {
        "use strict";

        module.exports = function setAttributes(element, attributes) {
          var value;

          for (var key in attributes) {
            if (attributes.hasOwnProperty(key)) {
              value = attributes[key];

              if (value == null) {
                element.removeAttribute(key);
              } else {
                element.setAttribute(key, value);
              }
            }
          }
        };
      },
      {}
    ],
    26: [
      function(require, module, exports) {
        "use strict";

        var noCallback = require("../libs/no-callback.js");
        var deferred = require("../libs/deferred.js");
        var Client = require("./client.js");
        /**
         * This module is the entry point to create
         * a client that communicates with interswitch
         * servers
         * @param options. Options object.
         * @param options.authorizationKey. The merchantId. This is used to uniquely identify each merchant.
         * @param callback. Callback containing the client.
         */
        var newInstanceValue = function newInstanceValue(options, callback) {
          //callback(null, null);
          //return;
          //check for no callback
          noCallback(callback, "newInstance");

          //check for deferred
          callback = deferred(callback);

          //create instance
          if (!options.authorization) {
            callback(
              new Error({
                message: "Authorization"
              })
            );
            return;
          }
          var client = new Client(options.authorization);
          callback(null, client);

          /**
           * do network I/O for configuration data
           */
        };

        module.exports = {
          newInstanceValue: newInstanceValue
        };
      },
      {
        "../libs/deferred.js": 9,
        "../libs/no-callback.js": 11,
        "./client.js": 27
      }
    ],
    27: [
      function(require, module, exports) {
        "use strict";

        var request = require("../request");
        var Client = function Client(authorization) {
          this.authorization = authorization;
        };

        Client.prototype.request = function(options, callback) {
          var optionName;

          if (!options.method) {
            optionName = "options.method";
          } else if (!options.endpoint) {
            optionsName = "options.endpoint";
          }

          if (optionName) {
            var err = new Error({
              message: "Bad Request " + optionName + "- not set"
            });

            callback(err);
            return;
          }

          this._request(
            {
              url: this._baseUrl + options.endpoint,
              method: options.method,
              data: options.data,
              headers: options.headers,
              timeout: options.timeout
            },
            this._functionCallback(callback)
          );
        };

        var _functionCallback = function _functionCallback(callback) {
          var err;
          return function(err, res, status) {
            if (status === -1) {
              err = new Error({
                message: "Timeout"
              });
              callback(err, null, status);
            } else if (status < 200 || status >= 400) {
              err = new Error({
                message: "Failure"
              });
              callback(err, null, status);
            } else {
              callback(null, res, status);
            }
          };
        };

        module.exports = Client;
      },
      { "../request": 17 }
    ],
    28: [
      function(require, module, exports) {
        (function(global) {
          "use strict";

          var win, framebus;
          var popups = [];
          var subscribers = {};
          var prefix = "/*framebus*/";

          function include(popup) {
            if (popup == null) {
              return false;
            }
            if (popup.Window == null) {
              return false;
            }
            if (popup.constructor !== popup.Window) {
              return false;
            }

            popups.push(popup);
            return true;
          }

          function target(origin) {
            var key;
            var targetedFramebus = {};

            for (key in framebus) {
              if (!framebus.hasOwnProperty(key)) {
                continue;
              }

              targetedFramebus[key] = framebus[key];
            }

            targetedFramebus._origin = origin || "*";

            return targetedFramebus;
          }

          function publish(event) {
            var payload, args;
            var origin = _getOrigin(this); // eslint-disable-line no-invalid-this

            if (_isntString(event)) {
              return false;
            }
            if (_isntString(origin)) {
              return false;
            }

            args = Array.prototype.slice.call(arguments, 1);

            payload = _packagePayload(event, args, origin);
            if (payload === false) {
              return false;
            }

            _broadcast(win.top || win.self, payload, origin);

            return true;
          }

          function subscribe(event, fn) {
            var origin = _getOrigin(this); // eslint-disable-line no-invalid-this

            if (_subscriptionArgsInvalid(event, fn, origin)) {
              return false;
            }

            subscribers[origin] = subscribers[origin] || {};
            subscribers[origin][event] = subscribers[origin][event] || [];
            subscribers[origin][event].push(fn);

            return true;
          }

          function unsubscribe(event, fn) {
            var i, subscriberList;
            var origin = _getOrigin(this); // eslint-disable-line no-invalid-this

            if (_subscriptionArgsInvalid(event, fn, origin)) {
              return false;
            }

            subscriberList = subscribers[origin] && subscribers[origin][event];
            if (!subscriberList) {
              return false;
            }

            for (i = 0; i < subscriberList.length; i++) {
              if (subscriberList[i] === fn) {
                subscriberList.splice(i, 1);
                return true;
              }
            }

            return false;
          }

          function _getOrigin(scope) {
            return (scope && scope._origin) || "*";
          }

          function _isntString(string) {
            return typeof string !== "string";
          }

          function _packagePayload(event, args, origin) {
            var packaged = false;
            var payload = {
              event: event,
              origin: origin
            };
            var reply = args[args.length - 1];

            if (typeof reply === "function") {
              payload.reply = _subscribeReplier(reply, origin);
              args = args.slice(0, -1);
            }

            payload.args = args;

            try {
              packaged = prefix + JSON.stringify(payload);
            } catch (e) {
              throw new Error("Could not stringify event: " + e.message);
            }
            return packaged;
          }

          function _unpackPayload(e) {
            var payload, replyOrigin, replySource, replyEvent;

            if (e.data.slice(0, prefix.length) !== prefix) {
              return false;
            }

            try {
              payload = JSON.parse(e.data.slice(prefix.length));
            } catch (err) {
              return false;
            }

            if (payload.reply != null) {
              replyOrigin = e.origin;
              replySource = e.source;
              replyEvent = payload.reply;

              payload.reply = function reply(data) {
                // eslint-disable-line consistent-return
                var replyPayload;

                if (!replySource) {
                  return false;
                }

                replyPayload = _packagePayload(replyEvent, [data], replyOrigin);

                if (replyPayload === false) {
                  return false;
                }

                replySource.postMessage(replyPayload, replyOrigin);
              };

              payload.args.push(payload.reply);
            }

            return payload;
          }

          function _attach(w) {
            if (win) {
              return;
            }
            win = w || global;

            if (win.addEventListener) {
              win.addEventListener("message", _onmessage, false);
            } else if (win.attachEvent) {
              win.attachEvent("onmessage", _onmessage);
            } else if (win.onmessage === null) {
              win.onmessage = _onmessage;
            } else {
              win = null;
            }
          }

          // removeIf(production)
          function _detach() {
            if (win == null) {
              return;
            }

            if (win.removeEventListener) {
              win.removeEventListener("message", _onmessage, false);
            } else if (win.detachEvent) {
              win.detachEvent("onmessage", _onmessage);
            } else if (win.onmessage === _onmessage) {
              win.onmessage = null;
            }

            win = null;
            popups = [];
            subscribers = {};
          }
          // endRemoveIf(production)

          function _uuid() {
            return "xxxxxxxx-xxxx-4xxx-yxxx-xxxxxxxxxxxx".replace(
              /[xy]/g,
              function(c) {
                var r = (Math.random() * 16) | 0;
                var v = c === "x" ? r : (r & 0x3) | 0x8;

                return v.toString(16);
              }
            );
          }

          function _onmessage(e) {
            var payload;

            if (_isntString(e.data)) {
              return;
            }

            payload = _unpackPayload(e);
            if (!payload) {
              return;
            }

            _dispatch("*", payload.event, payload.args, e);
            _dispatch(e.origin, payload.event, payload.args, e);
            _broadcastPopups(e.data, payload.origin, e.source);
          }

          function _dispatch(origin, event, args, e) {
            var i;

            if (!subscribers[origin]) {
              return;
            }
            if (!subscribers[origin][event]) {
              return;
            }

            for (i = 0; i < subscribers[origin][event].length; i++) {
              subscribers[origin][event][i].apply(e, args);
            }
          }

          function _hasOpener(frame) {
            if (frame.top !== frame) {
              return false;
            }
            if (frame.opener == null) {
              return false;
            }
            if (frame.opener === frame) {
              return false;
            }
            if (frame.opener.closed === true) {
              return false;
            }

            return true;
          }

          function _broadcast(frame, payload, origin) {
            var i = 0;
            var frameToBroadcastTo;

            try {
              frame.postMessage(payload, origin);

              if (_hasOpener(frame)) {
                _broadcast(frame.opener.top, payload, origin);
              }

              // previously, our max value was frame.frames.length
              // but frames.length inherits from window.length
              // which can be overwritten if a developer does
              // `var length = value;` outside of a function
              // scope, it'll prevent us from looping through
              // all the frames. With this, we loop through
              // until there are no longer any frames
              while ((frameToBroadcastTo = frame.frames[i])) {
                // eslint-disable-line no-cond-assign
                _broadcast(frameToBroadcastTo, payload, origin);
                i++;
              }
            } catch (_) {
              /* ignored */
            }
          }

          function _broadcastPopups(payload, origin, source) {
            var i, popup;

            for (i = popups.length - 1; i >= 0; i--) {
              popup = popups[i];

              if (popup.closed === true) {
                popups = popups.slice(i, 1);
              } else if (source !== popup) {
                _broadcast(popup.top, payload, origin);
              }
            }
          }

          function _subscribeReplier(fn, origin) {
            var uuid = _uuid();

            function replier(d, o) {
              fn(d, o);
              framebus.target(origin).unsubscribe(uuid, replier);
            }

            framebus.target(origin).subscribe(uuid, replier);
            return uuid;
          }

          function _subscriptionArgsInvalid(event, fn, origin) {
            if (_isntString(event)) {
              return true;
            }
            if (typeof fn !== "function") {
              return true;
            }
            if (_isntString(origin)) {
              return true;
            }

            return false;
          }

          _attach();

          framebus = {
            target: target,
            // removeIf(production)
            _packagePayload: _packagePayload,
            _unpackPayload: _unpackPayload,
            _attach: _attach,
            _detach: _detach,
            _dispatch: _dispatch,
            _broadcast: _broadcast,
            _subscribeReplier: _subscribeReplier,
            _subscriptionArgsInvalid: _subscriptionArgsInvalid,
            _onmessage: _onmessage,
            _uuid: _uuid,
            _getSubscribers: function() {
              return subscribers;
            },
            _win: function() {
              return win;
            },
            // endRemoveIf(production)
            include: include,
            publish: publish,
            pub: publish,
            trigger: publish,
            emit: publish,
            subscribe: subscribe,
            sub: subscribe,
            on: subscribe,
            unsubscribe: unsubscribe,
            unsub: unsubscribe,
            off: unsubscribe
          };

          module.exports = framebus;
        }.call(
          this,
          typeof global !== "undefined"
            ? global
            : typeof self !== "undefined"
            ? self
            : typeof window !== "undefined"
            ? window
            : {}
        ));
      },
      {}
    ]
  },
  {},
  [5]
);
